// WLServerDlg.h : wb_[ t@C
//

#if !defined(AFX_WLSERVERDLG_H__35ACBFEE_0AD5_48E5_8817_F52A841F40C9__INCLUDED_)
#define AFX_WLSERVERDLG_H__35ACBFEE_0AD5_48E5_8817_F52A841F40C9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "LSocket.h"
#include "CSocket.h"
#include "wave.h"
#include "ColorStatic.h"
#include "TButton.h"
//---------------------------------------------------------------------------
#define	STIMEOUT	3000
//---------------------------------------------------------------------------
typedef struct {
	int		m_ID;
    int		m_TxFifo;
    int		m_RxFifo;
    int		m_Channel;
}SPARA;
/////////////////////////////////////////////////////////////////////////////
// CWLServerDlg _CAO

class CWLServerDlg : public CDialog
{
private:
	CTcpFifo	m_TcpFifo;
	int			m_PortTCP;

	int     	m_ptt;

    int			m_InStatus;
    int			m_OutStatus;
    int			m_ReadStatus;
    int			m_WriteStatus;

	SPARA		m_SoundPara;

	CMD_OPEN	m_InData;
    CMD_OPEN	m_OutData;
	WAVEFORMATEX	m_WFX;
	RET_COUNTER	m_Counter;

	SHORT		m_InBuf[8192];
	CFifo		m_FifoTx;
    CFifo		m_FifoRx;

	CWave		m_Wave;

    HANDLE		m_hPort;

private:
	CLSocket	*m_pSocket;
	CPtrList	m_Connection;

private:
	CColorStatic	m_csDlgNStatus;
	CColorStatic	m_csDlgDevID;
	CColorStatic	m_csDlgTX;
	CColorStatic	m_csDlgRX;
	CColorStatic	m_csDlgPort;
	CToggleButton	m_tbDlgTX;

private:
	void CloseSocket(CCSocket *pSocket);
	BOOL SendBuf(CCSocket *pSocket, LPVOID p, int n);
	BOOL SendClient(LPVOID p, int len);
	BOOL SendClient(int cmd, LPVOID p, int len);
	
	void DispStatus(void);
	void DispSoundStat(void);
	void SetPTT(int sw);
	void InitWFX(const CMD_OPEN *pOpen);
	void WriteError(void);
	void SendCounter(void);
	void UpdateSoundPara(void);

	void OpenPort(void);
	LONG OpenPort_(void);
	void ClosePort(void);

public:
	void OnAccept(int nErrorCode);
	void OnReceive(CCSocket *pSocket, int nErrorCode);

// \z
public:
	CWLServerDlg(CWnd* pParent = NULL);	// W̃RXgN^

// _CAO f[^
	//{{AFX_DATA(CWLServerDlg)
	enum { IDD = IDD_WLSERVER_DIALOG };
	CButton	m_DlgMinimized;
	int		m_DlgDevID;
	int		m_DlgRXFIFO;
	int		m_DlgTXFIFO;
	int		m_DlgChannel;
	BOOL	m_DlgDTR;
	BOOL	m_DlgRTS;
	int		m_DlgPort;
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CWLServerDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	HICON m_hIcon;

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CWLServerDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSelchangeDevID();
	afx_msg void OnSelchangeRxfifo();
	afx_msg void OnSelchangeTxfifo();
	afx_msg void OnRmono();
	afx_msg void OnRleft();
	afx_msg void OnRright();
	afx_msg void OnDtr();
	afx_msg void OnRts();
	afx_msg void OnBtx();
	afx_msg void OnSelchangePort();
	afx_msg void OnMinimize();
	//}}AFX_MSG
	afx_msg LRESULT OnWaveEvent(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnSocketEvent(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_WLSERVERDLG_H__35ACBFEE_0AD5_48E5_8817_F52A841F40C9__INCLUDED_)
